package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(IISLProjectionMethods_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public interface IISLProjectionMethods  extends IISLStandardMethods {
	
	
	/*** PROTECTED REGION ID(IISLProjectionMethods_userCode) ENABLED START ***/
	public <T extends IISLProjectionMethods> T projectOut(ISLDimType dimType, int pos, int num);
	
	public default <T extends IISLProjectionMethods> T projectOnto(ISLDimType dimType, int pos) {
		T res = this.copy();
		int ndims = this.dim(dimType);
		if (pos < 0 || pos >= ndims)
			throw new IllegalArgumentException();
		if (pos>0)
			res = res.projectOut(dimType,0,pos);
		if (pos<ndims-1)
			res = res.projectOut(dimType,1,ndims-pos-1);
		return res;
	}
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	
	
}
